// Deatils about the Ortur LaserMaster 2 Pro:
// https://homofaciens.de/technics-machines-Ortur-Laser-Master-2-Pro_en.htm

M3_hole = 3.4;
M3_nut_e = 6.4;
M4_hole = 4.4;
M4_nut_e = 7.66+0.5;
M5_nut_e = 8.79+0.5;
M6_nut_e = 11.05+0.5;
M10_nut_e = 18.9 + 0.8;
t = true;
$fn = 100;

translate([0, 0, 100])
rotate([90, 0, 0])
laser_mount();

module laser_mount(){
  lm_wall = 2;
  lm_w = 40;
  lm_l1 = 65;
  lm_l2 = 200;
  lm_h = 70;
  screw_dis_x = 16;
  screw_dis_y = 45;
  
  difference(){
    cube(size=[lm_w,lm_l2,lm_h], center=true);

    translate([0, lm_l2/2-17, 0])
      cylinder(d=14, h = lm_h * 10.1, center=true);

    translate([screw_dis_x/2, (lm_l2-lm_l1 + screw_dis_y)/2, 0])
      cylinder(d=M3_hole, h = lm_h * 10.1, center=true);
    translate([screw_dis_x/2, (lm_l2-lm_l1 - screw_dis_y)/2, 0])
      cylinder(d=M3_hole, h = lm_h * 10.1, center=true);
    translate([-screw_dis_x/2, (lm_l2-lm_l1 - screw_dis_y)/2, 0])
      cylinder(d=M3_hole, h = lm_h * 10.1, center=true);
    translate([-screw_dis_x/2, (lm_l2-lm_l1 + screw_dis_y)/2, 0])
      cylinder(d=M3_hole, h = lm_h * 10.1, center=true);

    translate([screw_dis_x/2, -(lm_l2-lm_l1 + screw_dis_y)/2, 0])
      cylinder(d=M3_hole, h = lm_h * 10.1, center=true);
    translate([screw_dis_x/2, -(lm_l2-lm_l1 - screw_dis_y)/2, 0])
      cylinder(d=M3_hole, h = lm_h * 10.1, center=true);
    translate([-screw_dis_x/2, -(lm_l2-lm_l1 - screw_dis_y)/2, 0])
      cylinder(d=M3_hole, h = lm_h * 10.1, center=true);
    translate([-screw_dis_x/2, -(lm_l2-lm_l1 + screw_dis_y)/2, 0])
      cylinder(d=M3_hole, h = lm_h * 10.1, center=true);

    translate([lm_w/2-lm_wall, 0.1, lm_wall])
    rotate([-90, 0, 90]){
      linear_extrude(height = lm_w - 2*lm_wall){
        x1 = lm_l2/2;
        y1 = lm_h/2;
        x2 = lm_l2/2 - lm_l1;
        y2 = y1;
        x3 = lm_l1 - lm_l2/2;
        y3 = -lm_h/2;
        x4 = x1;
        y4 = -lm_h/2;
        polygon(points=[[x1,y1],[x2,y2],[x3,y3],[x4,y4]]);
      }
      translate([10, 0, -lm_wall-0.1])
      linear_extrude(height = lm_w +1){
        x1 = lm_l2/2;
        y1 = lm_h/2;
        x2 = 90;
        y2 = y1;
        x3 = lm_l1 - lm_l2/2 - 11;
        y3 = -lm_h/2;
        x4 = x1;
        y4 = -lm_h/2;
        polygon(points=[[x1,y1],[x2,y2],[x3,y3],[x4,y4]]);
      }
    }

    difference(){
      translate([lm_w/2-lm_wall, 2, -lm_wall])
      rotate([90, 0, 270]){
        linear_extrude(height = lm_w - 2*lm_wall){
          x1 = lm_l2/2;
          y1 = lm_h/2;
          x2 = lm_l2/2 - lm_l1;
          y2 = y1;
          x3 = lm_l1 - lm_l2/2;
          y3 = -lm_h/2;
          x4 = x1;
          y4 = -lm_h/2;
          polygon(points=[[x1,y1],[x2,y2],[x3,y3],[x4,y4]]);
        }
      }
      translate([screw_dis_x/2, -(lm_l2-lm_l1 + screw_dis_y)/2, lm_h/2-3])
        difference(){
          cylinder(d1=8, d2=20, h = 10, center=true);
          rotate([0, 0, 30])
          cylinder(d=M3_nut_e, h = 10.1, center=true, $fn=6);
        }
      translate([screw_dis_x/2, -(lm_l2-lm_l1 - screw_dis_y)/2, lm_h/2-3])
        difference(){
          cylinder(d1=8, d2=20, h = 10, center=true);
          rotate([0, 0, 30])
          cylinder(d=M3_nut_e, h = 10.1, center=true, $fn=6);
        }
      translate([-screw_dis_x/2, -(lm_l2-lm_l1 - screw_dis_y)/2, lm_h/2-3])
        difference(){
          cylinder(d1=8, d2=20, h = 10, center=true);
          rotate([0, 0, 30])
          cylinder(d=M3_nut_e, h = 10.1, center=true, $fn=6);
        }
      translate([-screw_dis_x/2, -(lm_l2-lm_l1 + screw_dis_y)/2, lm_h/2-3])
        difference(){
          cylinder(d1=8, d2=20, h = 10, center=true);
          rotate([0, 0, 30])
          cylinder(d=M3_nut_e, h = 10.1, center=true, $fn=6);
        }
    }

  }
  
} 
